/********************************************************************
 *  Cg[T hCo֐ Rev 2.0
 *  CQ-FRK-NXP-ARM p, J@IAREW IDE V5.30
 ********************************************************************/

#include "cq_bbltr_m_nxp.h"
#include "driver.h"

/********************************************************************
 * CPU
 ********************************************************************/
/* CPUNbNDCCLK=72MHzƂ */
void cpu_init(void)
{
    /* PLLNbNU */

    /* łPLL쒆ꍇ͒~ */
    if ( CLK_PLLSTAT & (1<<25) ) {
        /* PLLCON - PLL Enable & disconnected */
        CLK_PLLCON  = 0x00000001;
        /* PLL Feed operation */
        CLK_PLLFEED = 0x000000AA;
        CLK_PLLFEED = 0x00000055;
    }
    /* PLLCON - PLL Disable & disconnected(PLLS~) */
    CLK_PLLCON   = 0x00000000;
    /* PLL Feed operation */
    CLK_PLLFEED  = 0x000000AA;
    CLK_PLLFEED  = 0x00000055;

    SYS_SCS = 0x21; /* 12MHz OSC Enable & FGPIO Select */
    while((SYS_SCS&0x40) == 0){}    /* OSCSTAT Wait */

    /* CLKSRCSEL - MASTER oscillator select */
    CLK_CLKSRCSEL = 0x00000001;

    /* PLLCFG - MCLK=12MHz use, FCC0 = 288MHz M=144,N=12 */
    CLK_PLLCFG   = 0x000B008F;
    /* PLL Feed operation. */
    CLK_PLLFEED  = 0x000000AA;
    CLK_PLLFEED  = 0x00000055;

    /* PLLCON - PLL Enable & disconnected */
    CLK_PLLCON   = 0x00000001;
    /* PLL Feed operation */
    CLK_PLLFEED  = 0x000000AA;
    CLK_PLLFEED  = 0x00000055;

    /* CPU Clock Divider 1/4 */
    CLK_CCLKCFG   = 0x00000003;
    /* USB Clock Divider 1/6 */
    CLK_USBCLKCFG = 0x00000005;
    while ( ((CLK_PLLSTAT & (1<<26)) == 0) ); /* Check lock bit status */

    /* PLLCON - PLL Enable & Connected */
    CLK_PLLCON   = 0x00000003;
    /* PLL Feed operation. */
    CLK_PLLFEED  = 0x000000AA;
    CLK_PLLFEED  = 0x00000055;
    while ( ((CLK_PLLSTAT & (1<<25)) == 0) ); /* Check connect bit status */
}

/********************************************************************
 * PIN Control(FGPIO)
 * H} Pn M͑SẴO[vɑ
 *******************************************************************/
void pin_init(void)
{
    /* Cg[X{[hLED */
    FGPIO_FIO2DIR  |= 0x0000000F;    /* P2[0] ~ P2[3] o͒[qɂ */
    FGPIO_FIO2MASK = 0x00000000;    /* P2 ɂ͈؃}XNȂ */

    /* [^hCo */
    FGPIO_FIO3DIR  |= 0x0000003F;    /* P3[0] ~ P3[5] o͒[qɂ */
    FGPIO_FIO3MASK = 0x00000000;    /* P3ɂ͈؃}XNȂ */
}

void p20_set(int arg_status)
{
    FGPIO_FIO2PIN &= ~0x00000001;
    FGPIO_FIO2PIN |= arg_status << 0;
}

void p21_set(int arg_status)
{
    FGPIO_FIO2PIN &= ~0x00000002;
    FGPIO_FIO2PIN |= arg_status << 1;
}

void p22_set(int arg_status)
{
    FGPIO_FIO2PIN &= ~0x00000004;
    FGPIO_FIO2PIN |= arg_status << 2;
}

void p23_set(int arg_status)
{
    FGPIO_FIO2PIN &= ~0x00000008;
    FGPIO_FIO2PIN |= arg_status << 3;
}

void p30_set(int arg_status)
{
    FGPIO_FIO3PIN &= ~0x00000001;
    FGPIO_FIO3PIN |= arg_status << 0;
}

void p31_set(int arg_status)
{
    FGPIO_FIO3PIN &= ~0x00000002;
    FGPIO_FIO3PIN |= arg_status << 1;
}

void p32_set(int arg_status)
{
    FGPIO_FIO3PIN &= ~0x00000004;
    FGPIO_FIO3PIN |= arg_status << 2;
}

void p33_set(int arg_status)
{
    FGPIO_FIO3PIN &= ~0x00000008;
    FGPIO_FIO3PIN |= arg_status << 3;
}

void p34_set(int arg_status)
{
    FGPIO_FIO3PIN &= ~0x00000010;
    FGPIO_FIO3PIN |= arg_status << 4;
}

void p35_set(int arg_status)
{
    FGPIO_FIO3PIN &= ~0x00000020;
    FGPIO_FIO3PIN |= arg_status << 5;
}

/********************************************************************
 * PWM
 ********************************************************************/
#define PWM_PERIOD_COUNT		9000	/* NbN 9000KHz Ȃ̂Ŏ 1kHz */
#define PWM_INITIAL_DUTY_COUNT	(PWM_PERIOD_COUNT / 5)   /* PWM̏f[eB[ 20 % */

void pwm_init(void)
{
    /* d */
    PCONP |= (1 << 6);

    /* PWM֋NbN̐ݒ */
    PCLKSEL0 |= (3 << 12);    /* PCLK_PWM1 = (CCLK / 8 ) = 9MHz */

    /* PWMo͂s̐ݒ */
    GPIO_PINSEL3 |= (2 << 14);    /* P1_26 function PWM1.6 Select */
    GPIO_PINSEL3 |= (2 << 20);    /* P1_23 function PWM1.4 Select */
    GPIO_PINSEL7 |= (3 << 20);    /* P3_26 function PWM1.3 Select */

    /*
     * PWM1~3ڑĂ邪CgpĂȂs͂ɐݒ肵ĂD
     * iԂœ͂ɂȂĂ邪Ô߁j
     */
    GPIO_PINSEL0 &= ~(3 << 20);    /* P0_10 function GPIO Port 0.10 */
    GPIO_PINSEL7 &= ~(3 << 14);    /* P3_23 function GPIO Port 3.23 */
    GPIO_PINSEL3 &= ~(3 << 12);    /* P1_22 function GPIO Port 1.22 */
    FGPIO_FIO0DIR &= ~(1 << 10);    /* Port 0.10 input */
		FGPIO_FIO3DIR &= ~(1 << 23);    /* Port 3.23 input */
		FGPIO_FIO1DIR &= ~(1 << 22);    /* Port 1.22 input */

    /* PWMJE^ݒ */
    PWM1MCR |= (1 <<  1);  /* PWMTC(JE^)  PWMMR0vŃJE^Zbg */
    PWM1MCR |= (1 <<  9);  /* PWMMR3v荞݋(PWM~ɗp) */
	PWM1MCR |= (1 << 12);  /* PWMMR4v荞݋(PWM~ɗp) */
	PWM1MCR |= (1 << 18);  /* PWMMR6v荞݋(PWM~ɗp) */


    /* PWMRg[ݒ */
    PWM1MR0 = PWM_PERIOD_COUNT;    /* PWM */
    PWM1MR4 = PWM_INITIAL_DUTY_COUNT;    /* f[eB[䏉 */
    PWM1MR6 = PWM_INITIAL_DUTY_COUNT;    /* f[eB[䏉 */
    PWM1MR3 = PWM_INITIAL_DUTY_COUNT;    /* f[eB[䏉 */

    /* PWMytF̃JE^LɂPWM[hLɂ */
    PWM1TCR |= (1 << 0) | (1 << 3);    /* 0:Counter Enable, 3:PWM Enable */
}

void pwm_start(int arg_no)
{
    switch(arg_no){
    case 1:
        PWM1PCR |= (1 << 11);	/* PWM1_3 o͗L */
        break;
    case 2:
        PWM1PCR |= (1 << 14);	/* PWM1_6 o͗L */
        break;
    case 3:
        PWM1PCR |= (1 << 12);	/* PWM1_4 o͗L */
        break;
    default:
        break;
    }
}

/*
 * ~Ԃŏo͂ Low ɂȂ悤ɂD
 * ~܂ōő 1msec ̃rW[EFCg邪CVvȂ߂̕@̗p
 */
void pwm_stop(int arg_no)
{
    switch(arg_no){
    case 1:
        /*
         * }b`tOłɃZbgĂꍇl
         * }b`tONA
         */
        PWM1IR |= 0x0008;
        while(!(PWM1IR & 0x0008)){;}   /* }b`tOZbg(PWMo͂LowɂȂ)܂ő҂ */
        PWM1PCR &= ~(1 << 11);	/* PWM1_3 o͖ */
        break;
    case 2:
        /*
         * }b`tOłɃZbgĂꍇl
         * }b`tONA
         */
        PWM1IR |= 0x0400;
        while(!(PWM1IR & 0x0400)){;}   /* }b`tOZbg(PWMo͂LowɂȂ)܂ő҂ */
        PWM1PCR &= ~(1 << 14);	/* PWM1_6 o͖ */
        break;
    case 3:
        /*
         * }b`tOłɃZbgĂꍇl
         * }b`tONA
         */
        PWM1IR |= 0x0100;
        while(!(PWM1IR & 0x0100)){;}   /* }b`tOZbg(PWMo͂LowɂȂ)܂ő҂ */
        PWM1PCR &= ~(1 << 12);	/* PWM1_4 o͖ */
        break;
    default:
        break;
    }
}

/*
 * 0%, 100% ͈Ӑ}g`ɂȂȂ̂ŔĂ
 *
 */
#define DUTY_MIN	1
#define DUTY_MAX	99
void pwm1_set_ratio(int arg_percentage)
{
    /* 0 Ə] */
    if (arg_percentage < DUTY_MIN){
        arg_percentage = DUTY_MIN;
    }

    /* 100  pwm_stop֐Œ~łȂ */
    if (arg_percentage > DUTY_MAX){
        arg_percentage = DUTY_MAX;
    }

    PWM1MR3 = (PWM_PERIOD_COUNT * arg_percentage) / 100;  /* Vf[eB[̐ݒ */
    PWM1LER |= (1 << 3);            /* ̃JE^ZbgɃZbg悤ɂ */
}

void pwm2_set_ratio(int arg_percentage)
{
    /* 0 Ə] */
    if (arg_percentage < DUTY_MIN){
        arg_percentage = DUTY_MIN;
    }

    /* 100  pwm_stop֐Œ~łȂ */
    if (arg_percentage > DUTY_MAX){
        arg_percentage = DUTY_MAX;
    }

    PWM1MR6 = (PWM_PERIOD_COUNT * arg_percentage) / 100;  /* Vf[eB[̐ݒ */
    PWM1LER |= (1 << 6);            /* ̃JE^ZbgɃZbg悤ɂ */
}

void pwm3_set_ratio(int arg_percentage)
{
    /* 0 Ə] */
    if (arg_percentage < DUTY_MIN){
        arg_percentage = DUTY_MIN;
    }

    /* 100  pwm_stop֐Œ~łȂ */
    if (arg_percentage > DUTY_MAX){
        arg_percentage = DUTY_MAX;
    }

    PWM1MR4 = (PWM_PERIOD_COUNT * arg_percentage) / 100;  /* Vf[eB[̐ݒ */
    PWM1LER |= (1 << 4);            /* ̃JE^ZbgɃZbg悤ɂ */
}

/********************************************************************
 * A/DRo[^
 ********************************************************************/
#define AD_VALUE_MAX	0x03FF

void ad_init(void)
{
    /* A/DRo[^𗘗p鏀 */
    PCONP |= (1 << 12); /* A/DRo[^̓dONɂ */
    PCLKSEL0 |= (1 << 24); /* A/DCPUNbN */

    /* A/DRo[^̎gCPUNbN1/16 */
    AD0CR |= (16 << 8); 

    /* A/DLɂ */
    AD0CR |= (1 << 21);

    /* AiO̓s̐ݒ */
    GPIO_PINSEL1 = (GPIO_PINSEL1 & 0xffff3fff) | (0x1U << 14);	/* P0[23]sAD0ƂĎgp */
    GPIO_PINSEL1 = (GPIO_PINSEL1 & 0xfffcffff) | (0x1U << 16);	/* P0[24]sAD1ƂĎgp */
    GPIO_PINSEL1 = (GPIO_PINSEL1 & 0xfff3ffff) | (0x1U << 18);	/* P0[25]sAD2ƂĎgp */
	GPIO_PINSEL1 = (GPIO_PINSEL1 & 0xffcfffff) | (0x1U << 20);	/* P0[26]sAD3ƂĎgp */
	GPIO_PINSEL3 = (GPIO_PINSEL3 & 0xcfffffff) | (0x3U << 28);	/* P3[30]sAD4ƂĎgp */
	GPIO_PINSEL3 = (GPIO_PINSEL3 & 0x3fffffff) | (0x3U << 30);	/* P3[31]sAD5ƂĎgp */
	GPIO_PINSEL0 = (GPIO_PINSEL0 & 0xfcffffff) | (0x3U << 24);	/* P0[12]sAD6ƂĎgp */
	GPIO_PINSEL0 = (GPIO_PINSEL0 & 0xf3ffffff) | (0x3U << 26);	/* P0[13]sAD7ƂĎgp */
}

int ad00_get(void)
{
    int ret_ch0_analog_value;

    AD0CR = (AD0CR & 0xffffff00) | (0x01 << 0); /* A/D0Lɂ */
    ret_ch0_analog_value = AD0DR0;  /* WX^ǂݏoăNA */
    AD0CR = (AD0CR & 0xf8ffffff) | (1 << 24); /* ADϊJn */
    while (AD0DR0 & 0x80000000);
    ret_ch0_analog_value = (AD0DR0 >> 6) & 0x000003ff;

    ret_ch0_analog_value = (ret_ch0_analog_value * 100) / AD_VALUE_MAX;
    return ret_ch0_analog_value;
}

int ad01_get(void)
{
    int ret_ch1_analog_value;

    AD0CR = (AD0CR & 0xffffff00) | (0x01 << 1); /* A/D1Lɂ */
    ret_ch1_analog_value = AD0DR1;  /* WX^ǂݏoăNA */
    AD0CR = (AD0CR & 0xf8ffffff) | (1 << 24); /* ADϊJn */
    while (AD0DR1 & 0x80000000);
    ret_ch1_analog_value = (AD0DR1 >> 6) & 0x000003ff;

    ret_ch1_analog_value = (ret_ch1_analog_value * 100) / AD_VALUE_MAX;
    return ret_ch1_analog_value;
}

int ad02_get(void)
{
    int ret_ch2_analog_value;

    AD0CR = (AD0CR & 0xffffff00) | (0x01 << 2); /* A/D2Lɂ */
    ret_ch2_analog_value = AD0DR2;  /* WX^ǂݏoăNA */
    AD0CR = (AD0CR & 0xf8ffffff) | (1 << 24); /* ADϊJn */
    while (AD0DR2 & 0x80000000);
    ret_ch2_analog_value = (AD0DR2 >> 6) & 0x000003ff;

    ret_ch2_analog_value = (ret_ch2_analog_value * 100) / AD_VALUE_MAX;
    return ret_ch2_analog_value;
}

int ad03_get(void)
{
    int ret_ch3_analog_value;

    AD0CR = (AD0CR & 0xffffff00) | (0x01 << 3); /* A/D3Lɂ */
    ret_ch3_analog_value = AD0DR3;  /* WX^ǂݏoăNA */
    AD0CR = (AD0CR & 0xf8ffffff) | (1 << 24); /* ADϊJn */
    while (AD0DR3 & 0x80000000);
    ret_ch3_analog_value = (AD0DR3 >> 6) & 0x000003ff;

    ret_ch3_analog_value = (ret_ch3_analog_value * 100) / AD_VALUE_MAX;
    return ret_ch3_analog_value;
}

int ad04_get(void)
{
    int ret_ch4_analog_value;

    AD0CR = (AD0CR & 0xffffff00) | (0x01 << 4); /* A/D4Lɂ */
    ret_ch4_analog_value = AD0DR4;  /* WX^ǂݏoăNA */
    AD0CR = (AD0CR & 0xf8ffffff) | (1 << 24); /* ADϊJn */
    while (AD0DR4 & 0x80000000);
    ret_ch4_analog_value = (AD0DR4 >> 6) & 0x000003ff;

    ret_ch4_analog_value = (ret_ch4_analog_value * 100) / AD_VALUE_MAX;
    return ret_ch4_analog_value;
}

int ad05_get(void)
{
    int ret_ch5_analog_value;

    AD0CR = (AD0CR & 0xffffff00) | (0x01 << 5); /* A/D5Lɂ */
    ret_ch5_analog_value = AD0DR5;  /* WX^ǂݏoăNA */
    AD0CR = (AD0CR & 0xf8ffffff) | (1 << 24); /* ADϊJn */
    while (AD0DR5 & 0x80000000);
    ret_ch5_analog_value = (AD0DR5 >> 6) & 0x000003ff;

    ret_ch5_analog_value = (ret_ch5_analog_value * 100) / AD_VALUE_MAX;
    return ret_ch5_analog_value;
}

int ad06_get(void)
{
    int ret_ch6_analog_value;

    AD0CR = (AD0CR & 0xffffff00) | (0x01 << 6); /* A/D6Lɂ */
    ret_ch6_analog_value = AD0DR6;  /* WX^ǂݏoăNA */
    AD0CR = (AD0CR & 0xf8ffffff) | (1 << 24); /* ADϊJn */
    while (AD0DR6 & 0x80000000);
    ret_ch6_analog_value = (AD0DR6 >> 6) & 0x000003ff;

    ret_ch6_analog_value = (ret_ch6_analog_value * 100) / AD_VALUE_MAX;
    return ret_ch6_analog_value;
}

int ad07_get(void)
{
    int ret_ch7_analog_value;

    AD0CR = (AD0CR & 0xffffff00) | (0x01 << 7); /* A/D7Lɂ */
    ret_ch7_analog_value = AD0DR7;  /* WX^ǂݏoăNA */
    AD0CR = (AD0CR & 0xf8ffffff) | (1 << 24); /* ADϊJn */
    while (AD0DR7 & 0x80000000);
    ret_ch7_analog_value = (AD0DR7 >> 6) & 0x000003ff;

    ret_ch7_analog_value = (ret_ch7_analog_value * 100) / AD_VALUE_MAX;
    return ret_ch7_analog_value;
}

/********************************************************************
 * ^C}[
 ********************************************************************/
void timer_init(void)
{
    /* TIMER0̃NbNI */
    PCLKSEL0 |= (3 << 2);  // 72MHz / 8 = 9MHz

    /* 1~bƂɃ}b`悤 Timer0̃p[^ݒ */
    TIMER0_PR = 1;          /* vXP[ 1/2 */
    TIMER0_MR = 4500;       /* MR0 = 4500 <=> 1~b  */
    /* 
     * MatchɃJE^NAC荞݋
     * IRWX^̃rbgZbg邽߂ɋ
     * ۂɊ荞ݏ͍sȂ
     */
    TIMER0_MCR = 0x00000003;
}

void timer_start(void)
{
    TIMER0_TCR = 1;
}

void timer_stop(void)
{
    TIMER0_TCR = 2; /* Xgbv  JE^Zbg */
}

int timer_check_match(void)
{
    int is_match;
    if((TIMER0_IR & 0x01) == 0x01){
        TIMER0_IR |= 1;    /* }b`tONA */
        is_match = TIMER_CHECK_MATCH_TRUE;
    }else{
        is_match = TIMER_CHECK_MATCH_FALSE;
    }
    return is_match;
}
